Index: trunk/src/VBox/VMM/VMMAll/IEMAllCImplVmxInstr.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/IEMAllCImplVmxInstr.cpp	(revision 97041)
+++ trunk/src/VBox/VMM/VMMAll/IEMAllCImplVmxInstr.cpp	(revision 97042)
@@ -2860,5 +2860,5 @@
     uint32_t const     uInstrInfo = iemVmxGetExitInstrInfo(pVCpu, uExitReason, uInstrId, &GCPtrDisp);
 
-    VMXVEXITINFO const ExitInfo = VMXVEXITINFO_INIT_WITH_QUALIFIER_AND_INSTR_INFO(uExitReason, GCPtrDisp, uInstrInfo, cbInstr);
+    VMXVEXITINFO const ExitInfo = VMXVEXITINFO_INIT_WITH_QUAL_AND_INSTR_INFO(uExitReason, GCPtrDisp, uInstrInfo, cbInstr);
     return iemVmxVmexitInstrWithInfo(pVCpu, &ExitInfo);
 }
@@ -2875,5 +2875,5 @@
 VBOXSTRICTRC iemVmxVmexitInstrInvlpg(PVMCPUCC pVCpu, RTGCPTR GCPtrPage, uint8_t cbInstr) RT_NOEXCEPT
 {
-    VMXVEXITINFO const ExitInfo = VMXVEXITINFO_INIT_WITH_QUALIFIER_AND_INSTR_LEN(VMX_EXIT_INVLPG, GCPtrPage, cbInstr);
+    VMXVEXITINFO const ExitInfo = VMXVEXITINFO_INIT_WITH_QUAL_AND_INSTR_LEN(VMX_EXIT_INVLPG, GCPtrPage, cbInstr);
     Assert(IEM_GET_GUEST_CPU_FEATURES(pVCpu)->fLongMode || !RT_HI_U32(ExitInfo.u64Qual));
     return iemVmxVmexitInstrWithInfo(pVCpu, &ExitInfo);
@@ -2906,11 +2906,10 @@
         bool const fMemOperand = RT_BOOL(GCPtrEffDst != NIL_RTGCPTR);
         VMXVEXITINFO ExitInfo
-            = VMXVEXITINFO_INIT_WITH_QUALIFIER_AND_INSTR_LEN(VMX_EXIT_MOV_CRX,
-                                                               RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_REGISTER,  0) /* CR0 */
-                                                             | RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_LMSW_OP,   fMemOperand)
-                                                             | RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_LMSW_DATA, uNewMsw)
-                                                             | RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_ACCESS,
-                                                                          VMX_EXIT_QUAL_CRX_ACCESS_LMSW),
-                                                             cbInstr);
+            = VMXVEXITINFO_INIT_WITH_QUAL_AND_INSTR_LEN(VMX_EXIT_MOV_CRX,
+                                                          RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_REGISTER,  0) /* CR0 */
+                                                        | RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_LMSW_OP,   fMemOperand)
+                                                        | RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_LMSW_DATA, uNewMsw)
+                                                        | RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_ACCESS,  VMX_EXIT_QUAL_CRX_ACCESS_LMSW),
+                                                        cbInstr);
         if (fMemOperand)
         {
@@ -2964,9 +2963,9 @@
             Log2(("clts: Guest intercept -> VM-exit\n"));
             VMXVEXITINFO const ExitInfo
-                = VMXVEXITINFO_INIT_WITH_QUALIFIER_AND_INSTR_LEN(VMX_EXIT_MOV_CRX,
-                                                                   RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_REGISTER, 0) /* CR0 */
-                                                                 | RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_ACCESS,
-                                                                              VMX_EXIT_QUAL_CRX_ACCESS_CLTS),
-                                                                 cbInstr);
+                = VMXVEXITINFO_INIT_WITH_QUAL_AND_INSTR_LEN(VMX_EXIT_MOV_CRX,
+                                                              RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_REGISTER, 0) /* CR0 */
+                                                            | RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_ACCESS,
+                                                                         VMX_EXIT_QUAL_CRX_ACCESS_CLTS),
+                                                            cbInstr);
             return iemVmxVmexitInstrWithInfo(pVCpu, &ExitInfo);
         }
@@ -3008,10 +3007,9 @@
         Log2(("mov_Cr_Rd: (CR%u) Guest intercept -> VM-exit\n", iCrReg));
         VMXVEXITINFO const ExitInfo
-            = VMXVEXITINFO_INIT_WITH_QUALIFIER_AND_INSTR_LEN(VMX_EXIT_MOV_CRX,
-                                                               RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_REGISTER, iCrReg)
-                                                             | RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_GENREG,   iGReg)
-                                                             | RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_ACCESS,
-                                                                          VMX_EXIT_QUAL_CRX_ACCESS_WRITE),
-                                                             cbInstr);
+            = VMXVEXITINFO_INIT_WITH_QUAL_AND_INSTR_LEN(VMX_EXIT_MOV_CRX,
+                                                          RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_REGISTER, iCrReg)
+                                                        | RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_GENREG,   iGReg)
+                                                        | RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_ACCESS, VMX_EXIT_QUAL_CRX_ACCESS_WRITE),
+                                                        cbInstr);
         return iemVmxVmexitInstrWithInfo(pVCpu, &ExitInfo);
     }
@@ -3064,10 +3062,9 @@
         Log2(("mov_Rd_Cr: (CR3) Guest intercept -> VM-exit\n"));
         VMXVEXITINFO const ExitInfo
-            = VMXVEXITINFO_INIT_WITH_QUALIFIER_AND_INSTR_LEN(VMX_EXIT_MOV_CRX,
-                                                               RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_REGISTER, 3) /* CR3 */
-                                                             | RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_GENREG,   iGReg)
-                                                             | RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_ACCESS,
-                                                                          VMX_EXIT_QUAL_CRX_ACCESS_READ),
-                                                             cbInstr);
+            = VMXVEXITINFO_INIT_WITH_QUAL_AND_INSTR_LEN(VMX_EXIT_MOV_CRX,
+                                                          RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_REGISTER, 3) /* CR3 */
+                                                        | RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_GENREG,   iGReg)
+                                                        | RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_ACCESS, VMX_EXIT_QUAL_CRX_ACCESS_READ),
+                                                        cbInstr);
         return iemVmxVmexitInstrWithInfo(pVCpu, &ExitInfo);
     }
@@ -3100,10 +3097,10 @@
         Log2(("mov_Cr_Rd: (CR3) Guest intercept -> VM-exit\n"));
         VMXVEXITINFO const ExitInfo
-            = VMXVEXITINFO_INIT_WITH_QUALIFIER_AND_INSTR_LEN(VMX_EXIT_MOV_CRX,
-                                                               RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_REGISTER, 3) /* CR3 */
-                                                             | RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_GENREG,   iGReg)
-                                                             | RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_ACCESS,
-                                                                          VMX_EXIT_QUAL_CRX_ACCESS_WRITE),
-                                                             cbInstr);
+            = VMXVEXITINFO_INIT_WITH_QUAL_AND_INSTR_LEN(VMX_EXIT_MOV_CRX,
+                                                           RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_REGISTER, 3) /* CR3 */
+                                                         | RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_GENREG,   iGReg)
+                                                         | RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_ACCESS,
+                                                                      VMX_EXIT_QUAL_CRX_ACCESS_WRITE),
+                                                         cbInstr);
         return iemVmxVmexitInstrWithInfo(pVCpu, &ExitInfo);
     }
@@ -3132,10 +3129,9 @@
         Log2(("mov_Rd_Cr: (CR8) Guest intercept -> VM-exit\n"));
         VMXVEXITINFO const ExitInfo
-            = VMXVEXITINFO_INIT_WITH_QUALIFIER_AND_INSTR_LEN(VMX_EXIT_MOV_CRX,
-                                                               RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_REGISTER, 8) /* CR8 */
-                                                             | RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_GENREG,   iGReg)
-                                                             | RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_ACCESS,
-                                                                          VMX_EXIT_QUAL_CRX_ACCESS_READ),
-                                                             cbInstr);
+            = VMXVEXITINFO_INIT_WITH_QUAL_AND_INSTR_LEN(VMX_EXIT_MOV_CRX,
+                                                          RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_REGISTER, 8) /* CR8 */
+                                                        | RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_GENREG,   iGReg)
+                                                        | RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_ACCESS, VMX_EXIT_QUAL_CRX_ACCESS_READ),
+                                                        cbInstr);
         return iemVmxVmexitInstrWithInfo(pVCpu, &ExitInfo);
     }
@@ -3165,10 +3161,9 @@
         Log2(("mov_Cr_Rd: (CR8) Guest intercept -> VM-exit\n"));
         VMXVEXITINFO const ExitInfo
-            = VMXVEXITINFO_INIT_WITH_QUALIFIER_AND_INSTR_LEN(VMX_EXIT_MOV_CRX,
-                                                               RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_REGISTER, 8) /* CR8 */
-                                                             | RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_GENREG,   iGReg)
-                                                             | RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_ACCESS,
-                                                                          VMX_EXIT_QUAL_CRX_ACCESS_WRITE),
-                                                             cbInstr);
+            = VMXVEXITINFO_INIT_WITH_QUAL_AND_INSTR_LEN(VMX_EXIT_MOV_CRX,
+                                                          RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_REGISTER, 8) /* CR8 */
+                                                        | RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_GENREG,   iGReg)
+                                                        | RT_BF_MAKE(VMX_BF_EXIT_QUAL_CRX_ACCESS, VMX_EXIT_QUAL_CRX_ACCESS_WRITE),
+                                                        cbInstr);
         return iemVmxVmexitInstrWithInfo(pVCpu, &ExitInfo);
     }
@@ -3200,12 +3195,12 @@
     {
         VMXVEXITINFO const ExitInfo
-            = VMXVEXITINFO_INIT_WITH_QUALIFIER_AND_INSTR_LEN(VMX_EXIT_MOV_DRX,
-                                                               RT_BF_MAKE(VMX_BF_EXIT_QUAL_DRX_REGISTER,  iDrReg)
-                                                             | RT_BF_MAKE(VMX_BF_EXIT_QUAL_DRX_GENREG,    iGReg)
-                                                             | RT_BF_MAKE(VMX_BF_EXIT_QUAL_DRX_DIRECTION,
-                                                                          uInstrId == VMXINSTRID_MOV_TO_DRX
-                                                                          ? VMX_EXIT_QUAL_DRX_DIRECTION_WRITE
-                                                                          : VMX_EXIT_QUAL_DRX_DIRECTION_READ),
-                                                             cbInstr);
+            = VMXVEXITINFO_INIT_WITH_QUAL_AND_INSTR_LEN(VMX_EXIT_MOV_DRX,
+                                                          RT_BF_MAKE(VMX_BF_EXIT_QUAL_DRX_REGISTER,  iDrReg)
+                                                        | RT_BF_MAKE(VMX_BF_EXIT_QUAL_DRX_GENREG,    iGReg)
+                                                        | RT_BF_MAKE(VMX_BF_EXIT_QUAL_DRX_DIRECTION,
+                                                                     uInstrId == VMXINSTRID_MOV_TO_DRX
+                                                                     ? VMX_EXIT_QUAL_DRX_DIRECTION_WRITE
+                                                                     : VMX_EXIT_QUAL_DRX_DIRECTION_READ),
+                                                        cbInstr);
             return iemVmxVmexitInstrWithInfo(pVCpu, &ExitInfo);
     }
@@ -3237,13 +3232,13 @@
     {
         VMXVEXITINFO const ExitInfo
-            = VMXVEXITINFO_INIT_WITH_QUALIFIER_AND_INSTR_LEN(VMX_EXIT_IO_INSTR,
-                                                               RT_BF_MAKE(VMX_BF_EXIT_QUAL_IO_WIDTH,     cbAccess - 1)
-                                                             | RT_BF_MAKE(VMX_BF_EXIT_QUAL_IO_ENCODING,  fImm)
-                                                             | RT_BF_MAKE(VMX_BF_EXIT_QUAL_IO_PORT,      u16Port)
-                                                             | RT_BF_MAKE(VMX_BF_EXIT_QUAL_IO_DIRECTION,
-                                                                          uInstrId == VMXINSTRID_IO_IN
-                                                                          ? VMX_EXIT_QUAL_IO_DIRECTION_IN
-                                                                          : VMX_EXIT_QUAL_IO_DIRECTION_OUT),
-                                                             cbInstr);
+            = VMXVEXITINFO_INIT_WITH_QUAL_AND_INSTR_LEN(VMX_EXIT_IO_INSTR,
+                                                          RT_BF_MAKE(VMX_BF_EXIT_QUAL_IO_WIDTH,     cbAccess - 1)
+                                                        | RT_BF_MAKE(VMX_BF_EXIT_QUAL_IO_ENCODING,  fImm)
+                                                        | RT_BF_MAKE(VMX_BF_EXIT_QUAL_IO_PORT,      u16Port)
+                                                        | RT_BF_MAKE(VMX_BF_EXIT_QUAL_IO_DIRECTION,
+                                                                     uInstrId == VMXINSTRID_IO_IN
+                                                                     ? VMX_EXIT_QUAL_IO_DIRECTION_IN
+                                                                     : VMX_EXIT_QUAL_IO_DIRECTION_OUT),
+                                                        cbInstr);
         return iemVmxVmexitInstrWithInfo(pVCpu, &ExitInfo);
     }
@@ -3308,16 +3303,16 @@
 
         VMXVEXITINFO const ExitInfo
-            = VMXVEXITINFO_INIT_WITH_QUALIFIER_AND_INSTR_INFO_AND_LIN_ADDR(VMX_EXIT_IO_INSTR,
-                                                                             RT_BF_MAKE(VMX_BF_EXIT_QUAL_IO_WIDTH,   cbAccess - 1)
-                                                                           | RT_BF_MAKE(VMX_BF_EXIT_QUAL_IO_DIRECTION, uDirection)
-                                                                           | RT_BF_MAKE(VMX_BF_EXIT_QUAL_IO_IS_STRING, 1)
-                                                                           | RT_BF_MAKE(VMX_BF_EXIT_QUAL_IO_IS_REP,    fRep)
-                                                                           | RT_BF_MAKE(VMX_BF_EXIT_QUAL_IO_ENCODING,
-                                                                                        VMX_EXIT_QUAL_IO_ENCODING_DX)
-                                                                           | RT_BF_MAKE(VMX_BF_EXIT_QUAL_IO_PORT,      u16Port),
-                                                                           IEM_GET_GUEST_CPU_FEATURES(pVCpu)->fVmxInsOutInfo
-                                                                           ? ExitInstrInfo.u : 0,
-                                                                           cbInstr,
-                                                                           uGuestLinearAddr);
+            = VMXVEXITINFO_INIT_WITH_QUAL_AND_INSTR_INFO_AND_LIN_ADDR(VMX_EXIT_IO_INSTR,
+                                                                        RT_BF_MAKE(VMX_BF_EXIT_QUAL_IO_WIDTH,   cbAccess - 1)
+                                                                      | RT_BF_MAKE(VMX_BF_EXIT_QUAL_IO_DIRECTION, uDirection)
+                                                                      | RT_BF_MAKE(VMX_BF_EXIT_QUAL_IO_IS_STRING, 1)
+                                                                      | RT_BF_MAKE(VMX_BF_EXIT_QUAL_IO_IS_REP,    fRep)
+                                                                      | RT_BF_MAKE(VMX_BF_EXIT_QUAL_IO_ENCODING,
+                                                                                   VMX_EXIT_QUAL_IO_ENCODING_DX)
+                                                                      | RT_BF_MAKE(VMX_BF_EXIT_QUAL_IO_PORT,      u16Port),
+                                                                      IEM_GET_GUEST_CPU_FEATURES(pVCpu)->fVmxInsOutInfo
+                                                                      ? ExitInstrInfo.u : 0,
+                                                                      cbInstr,
+                                                                      uGuestLinearAddr);
         return iemVmxVmexitInstrWithInfo(pVCpu, &ExitInfo);
     }
@@ -3337,5 +3332,5 @@
 VBOXSTRICTRC iemVmxVmexitInstrMwait(PVMCPUCC pVCpu, bool fMonitorHwArmed, uint8_t cbInstr) RT_NOEXCEPT
 {
-    VMXVEXITINFO const ExitInfo = VMXVEXITINFO_INIT_WITH_QUALIFIER_AND_INSTR_LEN(VMX_EXIT_MWAIT, fMonitorHwArmed, cbInstr);
+    VMXVEXITINFO const ExitInfo = VMXVEXITINFO_INIT_WITH_QUAL_AND_INSTR_LEN(VMX_EXIT_MWAIT, fMonitorHwArmed, cbInstr);
     return iemVmxVmexitInstrWithInfo(pVCpu, &ExitInfo);
 }
@@ -9984,8 +9979,8 @@
             LogFlowFunc(("Raising APIC-access VM-exit from #PF handler at offset %#x\n", offAccess));
             VMXVEXITINFO const ExitInfo
-                = VMXVEXITINFO_INIT_WITH_QUALIFIER_AND_INSTR_LEN(VMX_EXIT_APIC_ACCESS,
-                                                                   RT_BF_MAKE(VMX_BF_EXIT_QUAL_APIC_ACCESS_OFFSET, offAccess)
-                                                                 | RT_BF_MAKE(VMX_BF_EXIT_QUAL_APIC_ACCESS_TYPE,   enmAccess),
-                                                                 HmExitAux.Vmx.cbInstr);
+                = VMXVEXITINFO_INIT_WITH_QUAL_AND_INSTR_LEN(VMX_EXIT_APIC_ACCESS,
+                                                              RT_BF_MAKE(VMX_BF_EXIT_QUAL_APIC_ACCESS_OFFSET, offAccess)
+                                                            | RT_BF_MAKE(VMX_BF_EXIT_QUAL_APIC_ACCESS_TYPE,   enmAccess),
+                                                            HmExitAux.Vmx.cbInstr);
             VMXVEXITEVENTINFO const ExitEventInfo = VMXVEXITEVENTINFO_INIT_ONLY_IDT(HmExitAux.Vmx.uIdtVectoringInfo,
                                                                                     HmExitAux.Vmx.uIdtVectoringErrCode);